/**
 * generated by Xtext 2.21.0
 */
package br.ufes.nemo.seon.ontoloyasservice.oaas;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Entity</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getDescription <em>Description</em>}</li>
 *   <li>{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getName <em>Name</em>}</li>
 *   <li>{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getSuperType <em>Super Type</em>}</li>
 *   <li>{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getEntity_type <em>Entity type</em>}</li>
 *   <li>{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getFunctions <em>Functions</em>}</li>
 *   <li>{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getRelations <em>Relations</em>}</li>
 * </ul>
 *
 * @see br.ufes.nemo.seon.ontoloyasservice.oaas.OaasPackage#getEntity()
 * @model
 * @generated
 */
public interface Entity extends AbstractElement
{
  /**
   * Returns the value of the '<em><b>Description</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Description</em>' containment reference.
   * @see #setDescription(Description)
   * @see br.ufes.nemo.seon.ontoloyasservice.oaas.OaasPackage#getEntity_Description()
   * @model containment="true"
   * @generated
   */
  Description getDescription();

  /**
   * Sets the value of the '{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getDescription <em>Description</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Description</em>' containment reference.
   * @see #getDescription()
   * @generated
   */
  void setDescription(Description value);

  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see br.ufes.nemo.seon.ontoloyasservice.oaas.OaasPackage#getEntity_Name()
   * @model
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Super Type</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Super Type</em>' reference.
   * @see #setSuperType(Entity)
   * @see br.ufes.nemo.seon.ontoloyasservice.oaas.OaasPackage#getEntity_SuperType()
   * @model
   * @generated
   */
  Entity getSuperType();

  /**
   * Sets the value of the '{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getSuperType <em>Super Type</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Super Type</em>' reference.
   * @see #getSuperType()
   * @generated
   */
  void setSuperType(Entity value);

  /**
   * Returns the value of the '<em><b>Entity type</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Entity type</em>' containment reference.
   * @see #setEntity_type(Entity_Type)
   * @see br.ufes.nemo.seon.ontoloyasservice.oaas.OaasPackage#getEntity_Entity_type()
   * @model containment="true"
   * @generated
   */
  Entity_Type getEntity_type();

  /**
   * Sets the value of the '{@link br.ufes.nemo.seon.ontoloyasservice.oaas.Entity#getEntity_type <em>Entity type</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Entity type</em>' containment reference.
   * @see #getEntity_type()
   * @generated
   */
  void setEntity_type(Entity_Type value);

  /**
   * Returns the value of the '<em><b>Attributes</b></em>' containment reference list.
   * The list contents are of type {@link br.ufes.nemo.seon.ontoloyasservice.oaas.Attribute}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Attributes</em>' containment reference list.
   * @see br.ufes.nemo.seon.ontoloyasservice.oaas.OaasPackage#getEntity_Attributes()
   * @model containment="true"
   * @generated
   */
  EList<Attribute> getAttributes();

  /**
   * Returns the value of the '<em><b>Functions</b></em>' containment reference list.
   * The list contents are of type {@link br.ufes.nemo.seon.ontoloyasservice.oaas.Function}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Functions</em>' containment reference list.
   * @see br.ufes.nemo.seon.ontoloyasservice.oaas.OaasPackage#getEntity_Functions()
   * @model containment="true"
   * @generated
   */
  EList<Function> getFunctions();

  /**
   * Returns the value of the '<em><b>Relations</b></em>' containment reference list.
   * The list contents are of type {@link br.ufes.nemo.seon.ontoloyasservice.oaas.Relation}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Relations</em>' containment reference list.
   * @see br.ufes.nemo.seon.ontoloyasservice.oaas.OaasPackage#getEntity_Relations()
   * @model containment="true"
   * @generated
   */
  EList<Relation> getRelations();

} // Entity
